<?php
//copyright jan 2008. ed.matteucci@gmail.com
//released under gpl v2
	class String{
		
		var $string;

		function String($M){
			$this->string=$M;
		}
		function setString($stringa){
			$this->string=$stringa;
		}
		function getStringa(){
			return $this->string;
		}
		
		function utf8_wordwrap($str,$width=75,$break=PHP_EOL, $cut=false){
    		return utf8_encode(wordwrap(utf8_decode(html_entity_decode($str)), $width, $break, $cut));
		}
		
		//<ciao cla="cdc"> -> </ciao>
		//<ciao> -> </ciao>
		//estrae il tag di chiusura da un tag passato
		//null nel caso la stringa non contenga un tag valido
		function closeTag(&$stringa){
			$posizioneiniziotag=stripos($stringa,"<");
			if($posizioneiniziotag===false){
				return "";
			}
			$posizionefinetag=stripos($stringa,">",$posizioneiniziotag);
			if($posizionefinetag===false){
				return "";
			}
			$posizioneopzionitag=stripos($stringa," ",$posizioneiniziotag);
			if($posizioneopzionitag===false){
				$tag=substr($stringa,$posizioneiniziotag,$posizionefinetag-$posizioneiniziotag+1);
			}else{
				$tag=substr($stringa,$posizioneiniziotag,$posizioneopzionitag-$posizioneiniziotag).">";
			}
			$inizio=stripos($tag,"</");
			if($inizio===false){
				//facciamo diventare il tag un tag di chiusura
				return str_replace("<","</",$tag);
			}else{
				return $tag;
			}
		}
		
		
		//restituisce un array con indicato:
		//il tag estratto e la posizione in cui viene a trovarsi il tag nella stringa iniziale
		function openTag(&$stringa,$offset=0){
			$posizioneiniziotag=stripos($stringa,"<",$offset);
			$posizionefinetag=stripos($stringa,">",$posizioneiniziotag);
			if($posizioneiniziotag===false||$posizionefinetag===false){
				return null;
			}else{
				return array(substr($stringa,$posizioneiniziotag,$posizionefinetag-$posizioneiniziotag+1),$posizioneiniziotag);
			}
		}
		//valuta se due tag vadano a chiudere una entità
		function twinTags($tagopen,$tagclose){
			if(empty($tagopen)||empty($tagclose)){
				return false;
			}
			$tagopen2close=String::closeTag($tagopen);
			return $tagopen2close==$tagclose;
			
		}
		
		function isCloseTag($stringa){
			$inizio=stripos($stringa,"</");
			if($inizio===false){
				return false;
			}
			$inizio2=stripos($stringa,">",$inizio);
			if($inizio2===false){
				return false;
			}
			return $inizio<$inizio2;
		}

		
		//restituisce il tag estratto e l'indice del tag
		function extractOpenTag(&$stringa,$offset){
			if(strlen($stringa)<$offset){
				return null;
			}
			
			$inizio=stripos($stringa,"<",$offset);
			if($inizio===false){
				return null;
			}
			$fine=stripos($stringa,">",$inizio);
			if($fine===false){
				return null;
			}
			$tagliato=stripos($stringa,"</",$offset);
			if($tagliato===false||($tagliato!=$inizio)){
				$prova=substr($stringa, $inizio, $fine+1-$inizio);
				return array($prova,$inizio);
			}else{
				return null;
			}
			
		}
		
		function extractTag(&$stringa,$offset,$limite){
			if(strlen($stringa)<$offset){
				return null;
			}
			
			$inizio=stripos($stringa,"<",$offset);
			if($inizio===false){
				return null;
			}
			
			if($inizio>$limite){
				return null;
			}
			
			$fine=stripos($stringa,">",$inizio);
			if($fine===false){
				return null;
			}
			
			$prova=substr($stringa, $inizio, $fine+1-$inizio);
			return array($prova,$inizio);
			
		}
		
		//input una stringa lunga a piacere con i tag html
		//ritorna: tutti i tag contenuti nei primi $lenght caratteri visibili della prima linea
		function estraiTagLineaHTML(&$stringa,$lenght){
			$limite=$lenght;
			$limite_old=-1;
			$it=1;
			$totale=0;
			$offset=0;
			$limitehard=stripos($stringa,PHP_EOL);
			if($limitehard===false){
				$limitehard=(strlen($stringa));
			}
			$htmltag=array();
			while($limite!=$limite_old){
				$limite_old=$limite;
				while(($tag=String::extractTag($stringa,$offset,$limite))!=null){
					$htmltag[]=$tag[0];
					
					$offset=$tag[1]+1;
					$totale+=strlen($tag[0]);
					$limite+=strlen($tag[0]);
					$limite=min($limite,$limitehard);
				}
				
			}
			return array("tagarray"=>$htmltag,"lunghezzatotale"=>($totale));

		}
		
		//funzione che elimina da un array di tag tutti i tag di chiusura
		function killtheEndingTags($array){
			$M=array();	
			
			foreach($array as $N){
				if(!String::isCloseTag($N)){
					$M[]=$N;	
				}
			}
			
			return $M;
		}
		
		//viene passato un array di tag "gemelli", ritorna l'array meno tutti i tag "gemelli"'
		function killtheTwinsTags($array){
			$ritornare=array();
			if(!empty($array)){
				$f=0;
				foreach($array as $elemento){
					if(String::twinTags($ritornare[$f],$elemento)){
						$ritornare[$f]="";
						unset($ritornare[$f]);				
						if($f!=0){
							$f--;	
						}
					}else{
						if($ritornare[$f]!=""){
							$f++;
						}
						$ritornare[$f]=$elemento;
					}
				}
			}
			return $ritornare;
		}
		
		function NgetHTMLLimited($stringa,$limiteFIXED=80){
			$stringaresidua=$stringa;
			
			while(!empty($stringaresidua)){
				$limite_prev=-1;
				$limite=$limiteFIXED;
				
				while($limite_prev!=$limite){
					$limite_prev=$limite;
					$taghtmlestratti=String::estraiTagLineaHTML($stringaresidua,$limite);
					$limite=$limiteFIXED+$taghtmlestratti[lunghezzatotale];
				}
				$wordwrappedstring=String::utf8_wordwrap($stringaresidua,$limite);
				
				if(($wordwraplimit=stripos($wordwrappedstring,PHP_EOL))===false){
					$stringaestratta=$stringaresidua;
					$stringaresidua="";
				}else{
					$stringaestratta=substr($stringaresidua,0,$wordwraplimit);
					$stringaresidua=substr($stringaresidua,$wordwraplimit);
				}
				
			}	
			
			
		}
		
		
		function getHTMLLimited2($stringa,$limiteFIXED=80){
			$stringaresidua=$stringa;
			$tagrestanti=array();
			$finale="";
			while(!empty($stringaresidua)){
				//all'inizio della riga metto i tag aperti
				if(!empty($taghtml)){
					$inizio="";
					foreach($taghtml as $tag){
						$inizio.=$tag;
					}
					$finale.=$inizio;
				}
				$limite_prev=-1;
				$limite=$limiteFIXED;
				
				while($limite_prev!=$limite){
					$limite_prev=$limite;
					$taghtmlestratti=String::estraiTagLineaHTML($stringaresidua,$limite);
					$limite=$limiteFIXED+$taghtmlestratti[lunghezzatotale];
				}

				$wordwrappedstring=String::utf8_wordwrap($stringaresidua,$limite);
				
				if(($wordwraplimit=stripos($wordwrappedstring,PHP_EOL))===false){
					$stringaestratta=$stringaresidua;
					$stringaresidua="";
				}else{
					$stringaestratta=substr($stringaresidua,0,$wordwraplimit);
					$stringaresidua=substr($stringaresidua,$wordwraplimit);
				}
				$finale.=$stringaestratta;
				$taghtml=String::killtheTwinsTags(array_merge($taghtml,$taghtmlestratti[tagarray]));

				if(!empty($taghtml)){
					$coda="";
					foreach($taghtml as $key){
						$coda=$key.$coda;	
					}
					$finale.=$coda;
				}
				if(!empty($stringaresidua)){
					$finale.=PHP_EOL;
				}

			}
			return $finale;
			
			
		}
		
		function spezzalineahtml($stringa,$lunghezza){
			$stringaresidua=$stringa;

			$finale="";
			while(!empty($stringaresidua)){
				$limite_prev=-1;
				$limite=$lunghezza;
				while($limite_prev!=$limite){
					$limite_prev=$limite;
					$taghtmlestratti=String::estraiTagLineaHTML($stringaresidua,$limite);
					$limite=$lunghezza+$taghtmlestratti[lunghezzatotale];
					$wordwrappedstring=String::utf8_wordwrap($stringaresidua,$limite);
					$wordwraplimit=stripos($wordwrappedstring,PHP_EOL);
					if($wordwraplimit===false){
						$limite=strlen($stringaresidua);	
					}else{
						$limite=$wordwraplimit;
					}
				}
				if($wordwraplimit==false){
					$stringaestratta=$stringaresidua;
					$stringaresidua="";
				}else{
					$stringaestratta=utf8_encode(substr(utf8_decode(html_entity_decode($stringaresidua)),0,$limite));
					$stringaresidua=utf8_encode(substr(utf8_decode(html_entity_decode($stringaresidua)),$limite));
				}
				$finale.=$stringaestratta;
				if(!empty($stringaresidua)){
					$finale.="".PHP_EOL;
				}else{$finale.="";
					}
			}
			return $finale;	
		}
		
		function lunghezzalinea($stringa){
			$M=String::estraiTagLineaHTML($stringa,strlen($stringa));
			$lunghezzatotale=strlen(html_entity_decode($stringa))-$M[lunghezzatotale];
			return $lunghezzatotale;
			
		}
		
		function getArrayLine($stringa,$pagina,$elementiperpagina,$limiteFIXED=80){
			$f=$elementiperpagina*$pagina; //(pagina 0 è la prima)
			$max=$f+$elementiperpagina;
			$array=String::getHTMLLimited($stringa,$limiteFIXED);
			$max=min($max,count($array));
			$return=array();
			if($f>=$max){
				$return=null;
			}else{
				for(;$f<$max;$f++){
					$return[]=$array[$f];
				}
			}
			return array("righeritornate"=>$return,"righetotali"=>count($array));
		}
		function getArrayLine2($stringa,$pagina,$righeperpagina,$limiteFIXED=80){
			
			
			$stringa_lower=strtolower($stringa);
			//le lettere devono essere minuscole
			$s1=str_replace("<br>","\n",$stringa_lower);
			$s2=str_replace("<p>","\n",$s1);
			$s3=str_replace("<br/>","\n",$s2);
			$s3=str_replace("\n\n","\n",$s2);
			//abbiamo testo diviso in righe attraverso i \n
			//eliminiamo i tag html che complicano la cosa
			$testo_stripped=strip_tags($s3);
			//
			$array=explode('\n',$testo_stripped);
			$totale=array();
			foreach($array as $linea){
				$N=String::utf8_wordwrap($linea,$limiteFIXED);
				$R=explode('\n',$N);
				$totale=array_merge($totale,$R);
			}
			
			$max=$f+$elementiperpagina;
			$max=min($max,count($totale));
			$return=array();
			$f=$elementiperpagina*$pagina; //(pagina 0 è la prima)
			if($f>=$max){
				$return=null;
			}else{
				for(;$f<$max;$f++){
					$return[]=$totale[$f];
				}
			}

			return array("righeritornate"=>$return,"righetotali"=>count($totale));
			
		}
		
		function getHTMLLimited($stringa,$limiteFIXED=80){
			$array=explode(PHP_EOL,$stringa);
			$totale="";
			for($f=0;$f<count($array);$f++){
				$linea=$array[$f];
				
				if(String::lunghezzalinea($linea)<=$limiteFIXED){
					$totale.=$linea;
				}else{
					$totale.=String::spezzalineahtml($linea,$limiteFIXED);
				}
				if(($f+1)<count($array)){
					$totale.=PHP_EOL;
				}
			}
			return explode(PHP_EOL,stripcslashes($totale));
		}
	}

?>