<?php
###############################################
# Authentication settings - read AUTHENTICATION
###############################################
$auth["session"] = "php"; # How to get and keep the user ID. One of
			  # "http" "php" "cookie" "ip" "host" "nt" "omni"
			  # "remote_user"
$auth["type"] = "config"; # How to validate the user/password. One of "none"
                          # "config" "db" "db_ext" "pop3" "imap" "ldap" "nis"
                          # "nw" "ext".

# Cookie path override. If this value is set it will be used by the
# 'php' and 'cookie' session schemes to override the default behaviour
# of automatically determining the cookie path to use
$cookie_path_override = '';

# The list of administrators (can modify other peoples settings)
$auth["admin"][] = "127.0.0.1";	# localhost IP address. Useful with IP sessions.
#$auth["admin"][] = "administrator";	# A user name from the user list. Useful 
                                    #with most other session schemes.
$auth["admin"][] = "demo";
#$auth["admin"][] = "10.0.0.1";
#$auth["admin"][] = "10.0.0.2";
#$auth["admin"][] = "10.0.0.3";

# 'auth_config' user database
# Format: $auth["user"]["name"] = "password";
$auth["user"]["utente"] = "prova";
$auth["user"]["demo"] = "demo";
# 'session_http' configuration settings
$auth["realm"]  = "mrbs";

# 'session_remote_user' configuration settings
#$auth['remote_user']['logout_link'] = '/logout/link.html';

# 'auth_ext' configuration settings
$auth["prog"]   = "";
$auth["params"] = "";

# 'auth_db_ext' configuration settings
$auth['db_ext']['db_host'] = 'localhost';
$auth['db_ext']['db_username'] = 'authuser';
$auth['db_ext']['db_password'] = 'authpass';
$auth['db_ext']['db_name'] = 'authdb';
$auth['db_ext']['db_table'] = 'users';
$auth['db_ext']['column_name_username'] = 'name';
$auth['db_ext']['column_name_password'] = 'password';
# Either 'md5', 'sha1', 'crypt' or 'plaintext'
$auth['db_ext']['password_format'] = 'md5';

# 'auth_ldap' configuration settings
# Where is the LDAP server
#$ldap_host = "localhost";
# If you have a non-standard LDAP port, you can define it here
#$ldap_port = 389;
# If you want to use LDAP v3, change the following to true
$ldap_v3 = false;
# If you want to use TLS, change following to true
$ldap_tls = false;
# LDAP base distinguish name
# See AUTHENTICATION for details of how check against multiple base dn's
#$ldap_base_dn = "ou=organizationalunit,dc=my-domain,dc=com";
# Attribute within the base dn that contains the username
#$ldap_user_attrib = "uid";

# 'auth_ldap' extra configuration for ldap configuration of who can use
# the system
# If it's set, the $ldap_filter will be combined with the value of
# $ldap_user_attrib like this:
#   (&($ldap_user_attrib=username)($ldap_filter))
# After binding to check the password, this check is used to see that
# they are a valid user of mrbs.
#$ldap_user_filter = "mrbsuser=y";

# 'auth_imap' configuration settings
# See AUTHENTICATION for details of how check against multiple servers
# Where is the IMAP server
$imap_host = "imap-server-name";
# The IMAP server port
$imap_port = "143";

# 'auth_pop3' configuration settings
# See AUTHENTICATION for details of how check against multiple servers
# Where is the POP3 server
$pop3_host = "pop3-server-name";
# The POP3 server port
$pop3_port = "110";
?>
