SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
CREATE TABLE IF NOT EXISTS `lista_eventi` (
`entry_id` int(11)
,`entry_created_by` varchar(80)
,`entry_teacher` varchar(80)
,`entry_description` text
,`entry_year` varchar(80)
,`entry_SSD` varchar(80)
,`entry_crediti` int(11)
,`entry_timestamp` timestamp
,`entry_CDL` int(11)
,`entry_shortitle` varchar(255)
,`entry_typeofdegree` tinyint(4)
,`entry_tipologialezione` tinyint(4)
,`occur_room_id` int(11)
,`occur_from_date` timestamp
,`occur_to_date` timestamp
,`occur_entry_id` int(11)
,`occur_weekday` tinyint(4)
,`occur_created_by` varchar(80)
,`occur_id` int(11)
,`occur_from_time` time
,`occur_to_time` time
,`occur_timestamp` timestamp
,`occur_typeoflesson` tinyint(4)
,`room_area_id` int(11)
,`room_id` int(11)
,`room_room_name` varchar(25)
,`room_description` varchar(60)
,`room_capacity` int(11)
,`room_room_admin_email` text
,`area_id` int(11)
,`area_area_name` varchar(80)
,`area_description` varchar(80)
,`area_area_admin_email` text
,`cdl_id` int(11)
,`cdl_descrizione` varchar(80)
);
-- --------------------------------------------------------

--
-- Struttura Stand-in per le viste `lista_news`
--
CREATE TABLE IF NOT EXISTS `lista_news` (
`news_from_date` date
,`news_to_date` date
,`news_limited` tinyint(1)
,`news_hidden` tinyint(1)
,`news_deleted` tinyint(1)
,`news_shortitle` varchar(500)
,`news_created_by` varchar(100)
,`news_timestamp` timestamp
,`news_text` text
,`news_id` int(11)
,`category_id` int(11)
,`category_description` varchar(50)
);
-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_area`
--

CREATE TABLE IF NOT EXISTS `mrbs_area` (
  `id` int(11) NOT NULL auto_increment,
  `area_name` varchar(80) default NULL,
  `description` varchar(80) default NULL,
  `area_admin_email` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_cdl`
--

CREATE TABLE IF NOT EXISTS `mrbs_cdl` (
  `id` int(11) NOT NULL auto_increment,
  `descrizione` varchar(80) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_entry2`
--

CREATE TABLE IF NOT EXISTS `mrbs_entry2` (
  `id` int(11) NOT NULL auto_increment,
  `created_by` varchar(80) NOT NULL default '',
  `teacher` varchar(80) NOT NULL default '',
  `description` text,
  `year` varchar(80) default NULL,
  `SSD` varchar(80) default NULL,
  `crediti` int(11) default NULL,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `CDL` int(11) NOT NULL default '0',
  `shortitle` varchar(255) NOT NULL default '',
  `typeofdegree` tinyint(4) NOT NULL default '0',
  `tipologialezione` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `CDL` (`CDL`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=301 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_log`
--

CREATE TABLE IF NOT EXISTS `mrbs_log` (
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `pagina` varchar(100) NOT NULL,
  `user` varchar(100) NOT NULL,
  `useragent` text NOT NULL,
  `richiesta` text NOT NULL,
  `versione` tinytext,
  `os` tinytext,
  `browser` tinytext,
  `id` int(11) NOT NULL auto_increment,
  `ip` tinytext NOT NULL,
  `cached` tinyint(1) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2406 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_log_time`
--

CREATE TABLE IF NOT EXISTS `mrbs_log_time` (
  `id` int(11) NOT NULL default '0',
  `time` float NOT NULL default '0',
  `descrizione` varchar(15) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_news`
--

CREATE TABLE IF NOT EXISTS `mrbs_news` (
  `id` int(11) NOT NULL auto_increment,
  `from_date` date NOT NULL,
  `to_date` date NOT NULL,
  `hidden` tinyint(1) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  `shortitle` varchar(500) NOT NULL,
  `created_by` varchar(100) NOT NULL,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `text` text NOT NULL,
  `category_id` int(11) default NULL,
  `senzalimiti` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=16 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_news_category`
--

CREATE TABLE IF NOT EXISTS `mrbs_news_category` (
  `id` int(11) NOT NULL auto_increment,
  `descrizione` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_occur`
--

CREATE TABLE IF NOT EXISTS `mrbs_occur` (
  `room_id` int(11) default NULL,
  `from_date` timestamp NULL default NULL,
  `to_date` timestamp NULL default NULL,
  `entry_id` int(11) default NULL,
  `weekday` tinyint(4) default NULL,
  `created_by` varchar(80) default NULL,
  `id` int(11) NOT NULL auto_increment,
  `from_time` time NOT NULL default '00:00:00',
  `to_time` time NOT NULL default '00:00:00',
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `typeoflesson` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `room_id` (`room_id`),
  KEY `entry_id` (`entry_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=411 ;

-- --------------------------------------------------------

--
-- Struttura della tabella `mrbs_room`
--

CREATE TABLE IF NOT EXISTS `mrbs_room` (
  `id` int(11) NOT NULL auto_increment,
  `area_id` int(11) default NULL,
  `room_name` varchar(25) NOT NULL default '',
  `description` varchar(60) default NULL,
  `capacity` int(11) NOT NULL default '0',
  `room_admin_email` text,
  PRIMARY KEY  (`id`),
  KEY `area_id` (`area_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=18 ;

-- --------------------------------------------------------

--
-- Struttura per la vista `lista_eventi`
--
DROP TABLE IF EXISTS `lista_eventi`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `mrbs-demo`.`lista_eventi` AS select `entry`.`id` AS `entry_id`,`entry`.`created_by` AS `entry_created_by`,`entry`.`teacher` AS `entry_teacher`,`entry`.`description` AS `entry_description`,`entry`.`year` AS `entry_year`,`entry`.`SSD` AS `entry_SSD`,`entry`.`crediti` AS `entry_crediti`,`entry`.`timestamp` AS `entry_timestamp`,`entry`.`CDL` AS `entry_CDL`,`entry`.`shortitle` AS `entry_shortitle`,`entry`.`typeofdegree` AS `entry_typeofdegree`,`entry`.`tipologialezione` AS `entry_tipologialezione`,`occur`.`room_id` AS `occur_room_id`,`occur`.`from_date` AS `occur_from_date`,`occur`.`to_date` AS `occur_to_date`,`occur`.`entry_id` AS `occur_entry_id`,`occur`.`weekday` AS `occur_weekday`,`occur`.`created_by` AS `occur_created_by`,`occur`.`id` AS `occur_id`,`occur`.`from_time` AS `occur_from_time`,`occur`.`to_time` AS `occur_to_time`,`occur`.`timestamp` AS `occur_timestamp`,`occur`.`typeoflesson` AS `occur_typeoflesson`,`room`.`area_id` AS `room_area_id`,`room`.`id` AS `room_id`,`room`.`room_name` AS `room_room_name`,`room`.`description` AS `room_description`,`room`.`capacity` AS `room_capacity`,`room`.`room_admin_email` AS `room_room_admin_email`,`area`.`id` AS `area_id`,`area`.`area_name` AS `area_area_name`,`area`.`description` AS `area_description`,`area`.`area_admin_email` AS `area_area_admin_email`,`cdl`.`id` AS `cdl_id`,`cdl`.`descrizione` AS `cdl_descrizione` from ((((`mrbs-demo`.`mrbs_room` `room` join `mrbs-demo`.`mrbs_area` `area` on((`room`.`area_id` = `area`.`id`))) join `mrbs-demo`.`mrbs_occur` `occur` on((`occur`.`room_id` = `room`.`id`))) join `mrbs-demo`.`mrbs_entry2` `entry` on((`entry`.`id` = `occur`.`entry_id`))) join `mrbs-demo`.`mrbs_cdl` `cdl` on((`entry`.`CDL` = `cdl`.`id`)));

-- --------------------------------------------------------

--
-- Struttura per la vista `lista_news`
--
DROP TABLE IF EXISTS `lista_news`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `mrbs-demo`.`lista_news` AS select `news`.`from_date` AS `news_from_date`,`news`.`to_date` AS `news_to_date`,`news`.`senzalimiti` AS `news_limited`,`news`.`hidden` AS `news_hidden`,`news`.`deleted` AS `news_deleted`,`news`.`shortitle` AS `news_shortitle`,`news`.`created_by` AS `news_created_by`,`news`.`timestamp` AS `news_timestamp`,`news`.`text` AS `news_text`,`news`.`id` AS `news_id`,`news_category`.`id` AS `category_id`,`news_category`.`descrizione` AS `category_description` from (`mrbs-demo`.`mrbs_news` `news` left join `mrbs-demo`.`mrbs_news_category` `news_category` on((`news`.`category_id` = `news_category`.`id`)));
