<?php
#28 settembre 2007 ed.matteucci@gmail.com
//invocazione. non invocare, includere nei file che utilizzeranno
//le funzioni definità
include_once "functions.inc.php";
include_once "functions_rm3.inc.php";
if (isset($auth['session'])) include_once "session_$auth[session].inc.php";

/* mrbsAddLesson()
 *
 * update one lesson into the db
 *
 * $description
 * $SSD
 * $crediti
 * $collegio
 * $created_by
 * $anno
 * $name
 * return: the id of the event
 */
function mrbsUpdateEvent($id,$name, $description, $shortitle, $typeofdegree,$collegio, $created_by, $anno, $SSD, $crediti)
{
	global $tbl_entry2;
	$sql="UPDATE $tbl_entry2 SET
			typeofdegree=$typeofdegree,
            created_by='".getUserName()."',
            teacher='".sql_sanitize_variable($name)."',
            description='".sql_sanitize_variable($description)."',
			shortitle='".sql_sanitize_variable($shortitle)."',
            year=$anno,
            SSD='".sql_sanitize_variable($SSD)."',
            crediti='$crediti',
            CDL='$collegio'
            WHERE id=$id";
	if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}

	return sql_insert_id("$tbl_entry2","id");
}


/* mrbsAddEvent()
 *
 * add one lesson to the db
 *
 * $description
 * $SSD
 * $crediti
 * $collegio
 * $created_by
 * $anno
 * $name
 * return: the id of the event
 */
function mrbsAddEvent($name, $description, $shortitle,$typeofdegree, $collegio, $created_by, $year, $SSD, $crediti)
{
	global $tbl_entry2;
	
	$sql="INSERT INTO $tbl_entry2 (
            created_by,
            teacher,
            description,
			shortitle,
			typeofdegree,
            year,
            SSD,
            crediti,
            CDL)VALUES(
            '".getUserName()."',
            '".sql_sanitize_variable($name)."',
            '".sql_sanitize_variable($description)."',
			'".sql_sanitize_variable($shortitle)."',       
			'$typeofdegree',
			'$year',
            '".sql_sanitize_variable($SSD)."',
            '$crediti',
            '$collegio'
            )";

    if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}

    return sql_insert_id("$tbl_entry2","id");
}

/* mrbsUpdateOccurence()
 *
 * ad one occurence to the database
 *
 * $room_id
 * $from_date
 * $to_date
 * $entry_id
 * $weekday
 * $created_by
 * $from_time
 * $to_time
 */
function mrbsUpdateOccurence($id,$room_id,$from_date,$to_date,$entry_id,$weekday,$created_by,$at_time,$to_time,$typeoflesson,$debug=0)
{
	global $tbl_occur;
	if($debug==1){
		echo "mrbsUpdateOccurence($id,$room_id,$from_date,$to_date,$entry_id,$weekday,$created_by,$at_time,$to_time,$typeoflesson,$debug=0)";
	}
	$from_date=convert_am7($from_date);
	$to_date=convert_pm7($to_date);
	$sql="UPDATE $tbl_occur SET
            room_id='$room_id',
            from_date=FROM_UNIXTIME($from_date),
            to_date=FROM_UNIXTIME($to_date),
            entry_id='$entry_id',
            weekday='$weekday',
            created_by='".getUserName()."',
            from_time='".strftime("%H:%M",$at_time)."',
            to_time='".strftime("%H:%M",$to_time)."',
            typeoflesson='$typeoflesson'
            
			WHERE id='$id'";

	if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}

	return sql_insert_id("$tbl_occur", "id");
}

/*TODO se non ci sono pi� occorrenze cancella l'entry?*/

function mrbsDelsOccurence($occur_id,$debug=0){
    global $tbl_occur;
    if($debug){
    	echo "mrbsDelsOccurence($occur_id,$debug)";
    }
    //TODO l'ordine non permette di rimuovere l'entry
    $sql="DELETE FROM $tbl_occur where id=$occur_id";
    if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
}


/* it fetchs the entry in the next @totime (not discarding the 
 *entry begun in the last @fromtime) in the current weekday and in the room @room
*/
function mrbsNextEntriesinRoom($date,$TOTIME,$FROMTIME,$debug=0){
	global $tbl_occur;
	global $tbl_entry2;
	global $tbl_room;
	global $tbl_area;
	$weekday=date("w",$date);
	if($debug==1){
		echo "mrbsNextEntriesinRoom(".date("r",$date).",$room_id,$TOTIME,$FROMTIME,$debug)";
	}
	//bisogna imporre un limite
	$sql="SELECT
			r.room_name,
			o.weekday,
			e.id entry_id, 
			o.from_time,
			o.to_time,
			e.teacher,
			e.shortitle,
			e.description,
			r.area_id
			FROM $tbl_occur o join $tbl_entry2 e
			on o.entry_id=e.id join $tbl_room r
			on r.id=o.room_id
			join $tbl_area a on a.id=r.area_id 
			WHERE from_date<=".sql_syntax_timestamp_to_unix($date)
.
			" AND to_date>=".sql_syntax_timestamp_to_unix($date)
.
			" AND weekday=$weekday AND 
			from_time<=ADDTIME(TIME(".sql_syntax_timestamp_to_unix($date)."),'$TOTIME')
			AND from_time>=TIMEDIFF(TIME(".sql_syntax_timestamp_to_unix($date)."),'$FROMTIME') order by from_time,a.description,r.room_name";

	$res = sql_query($sql);

	if (!$res) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	if(sql_count($res)>0){
		$count=0;
		while(($temp=sql_row_keyed($res,$count++))!=0){
			$from_time=array();
			sscanf($temp[from_time],"%d:%d:%d",$from_time[hour],$from_time[minute],$from_time[second]);
			$temp[from_time_sec]=3600*$from_time[hour]+60*$from_time[minute]+$from_time[second];
			$row[]=$temp;	
		}
	}
	return $row;
}

/*it fetchs the entry in the next @totime (not discarding the 
 *entry begun in the last @fromtime) on the current weekday in every room
*/
function mrbsNextEntries($date,$TOTIME,$FROMTIME,$debug=0){
	if($debug==1){
		echo "mrbsNextEntries(".date("r",$date).",$TOTIME,$FROMTIME,$debug)";
	}
	return mrbsNextEntriesinRoom($date,$TOTIME,$FROMTIME);
}

/*it fetch the entry in the current day @date for all the rooms
*/
function mrbsEntriesOfday($date,$debug=0){
	if($debug==1){
		echo "mrbsEntriesOfday(".date("r",$date).")";
	}
	$TOTIME=limitTime($date,"23:59:59");
	$FROMTIME=limitTime($date,"23:59:59",1);
	return mrbsNextEntriesinRoom($date,$TOTIME,$FROMTIME);
}


/* mrbsAddsOccurenceHOURMINUTES()
 *
 * ad one occurence to the database
 *
 * $room_id
 * $from_date timestamp da inserire
 * $to_date timestamp da inserire
 * $entry_id
 * $weekday intero da 0 a 6
 * $created_by
 * $from_time ora in formato H:M
 * $to_time  ora in formato  H:M
*/
function mrbsAddsOccurenceHM($room_id,$from_date,$to_date,$entry_id,$weekday,$created_by,$at_time,$to_time,$typeoflesson,$debug=0)
{
	if($debug==1){
		echo "mrbsAddsOccurenceHM($room_id,".date("r",$from_date).",".date("r",$to_date).",$entry_id,$weekday,$created_by,$at_time,$to_time,$typeoflesson,$debug)<br>\n";
	}
	$from_date=convert_am7($from_date);
	$to_date=convert_pm7($to_date);
    global $tbl_occur;
    $sql="INSERT INTO $tbl_occur (
            room_id,
            from_date,
            to_date,
            entry_id,
            weekday,
            created_by,
            from_time,
            to_time,
            typeoflesson)
            VALUES(
            '$room_id',
            FROM_UNIXTIME($from_date),
            FROM_UNIXTIME($to_date),
            '$entry_id',
            '$weekday',
            '".getUserName()."',
            '$at_time',
            '$to_time',
            $typeoflesson)";
    if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}


	return sql_insert_id("$tbl_occur", "id");
}

/* mrbsAddsOccurenceTS()
 *
 * ad one occurence to the database
 *
 * $room_id
 * $from_date timestamp da inserire
 * $to_date timestamp da inserire
 * $entry_id
 * $weekday intero da 0 a 6
 * $created_by
 * $from_time timestamp da convertire in formato H:M:S
 * $to_time  timestamp da convertire in formato H:M:S
*/

function mrbsAddsOccurenceTS($room_id,$from_date,$to_date,$entry_id,$weekday,$created_by,$at_time,$to_time,$typeoflesson,$debug=0){
	if($debug==1){
		echo "mrbsAddsOccurenceTS($room_id,".date("r",$from_date).",".date("r",$to_date).",$entry_id,$weekday,$created_by,".strftime("%H:%M",$at_time).",".strftime("%H:%M",$to_time).",$typeoflesson,$debug)<br>\n";
	}
	return mrbsAddsOccurenceHM($room_id,$from_date,$to_date,$entry_id,$weekday,$created_by,strftime("%H:%M",$at_time),strftime("%H:%M",$to_time),$typeoflesson,0);
}


/*
 * +1 se ts1<ts2
   = 0 se ts1==ts2
   -1 se ts1>ts2
   */

function compareday($ts1,$ts2,$debug=0){
	if($debug==1){
		echo "compareday(".date("r",$ts1).",".date("r",$ts2).",$debug)<br>\n";
	}
	//in php5 basta strtotime("today",$ts1);
	$ts1_today=mktime(0, 0, 0, date("m",$ts1)  , date("d",$ts1)+1, date("Y",$ts1));
	$ts2_today=mktime(0, 0, 0, date("m",$ts2)  , date("d",$ts2)+1, date("Y",$ts2));

	if($ts1_today<$ts2_today){
		return 1;
	}
	if($ts1_today>$ts2_today){
		return -1;
	}
	return 0;
	
}

function mrbsHandleOverlayedOccurence($id,$room_id_nuovoevento,$from_date_nuovoevento,$to_date_nuovoevento,$entry_id_nuovoevento,$weekday_nuovoevento,$created_by_nuovoevento,$at_time_nuovoevento,$to_time_nuovoevento,$typeoflesson_nuovoevento)
{	
	$debug=0;
    	if($debug==1){
    		echo "mrbsHandleOverlayedOccurence($id,$room_id_nuovoevento,".date("r",$from_date_nuovoevento).",".date("r",$to_date_nuovoevento).",$entry_id_nuovoevento,$weekday_nuovoevento,$created_by_nuovoevento,$at_time_nuovoevento,$to_time_nuovoevento,$typeoflesson_nuovoevento)<br>\n";
	}

    global $tbl_occur;
    $res=mrbsgetOverlays($room_id_nuovoevento, $at_time_nuovoevento, $to_time_nuovoevento, $weekday_nuovoevento,$from_date_nuovoevento,$to_date_nuovoevento,$id,$debug);
    $count=0;
    
    while($vecchioevento=sql_row_keyed($res,$count++)){
    		

			//caso 1, il nuovo evento inizia PRIMA del vecchio evento e termina 
			// dopo l'inizio (se terminasse prima non ci sarebbe interferenza)
			//due possibilit�: termina prima della fine o termina dopo la fine
			//la scelta tra le due possibilit� si far� dopo

		if(compareday($vecchioevento['from_date'],$to_date_nuovoevento)>=0&&
			compareday($from_date_nuovoevento,$vecchioevento['from_date'])>=0){
	    			if($debug==1){
	    				echo "caso 1<br>\n";
	    			}
	    			$from_date_vecchioevento=strtotime("+1 day",$to_date_nuovoevento);
	    			$to_date_vecchioevento=$vecchioevento['to_date'];
    			
    		}
    		if(compareday($vecchioevento['from_date'],$from_date_nuovoevento)>0){
    			//il nuovo evento capita in mezzo al vecchio
            //2 possibilit�
           	//questa � la met� a destra del evento (viene dopo)
           	if($debug){
           		echo "caso 2<br>\n";
           	}
           	$from_date_vecchioevento=strtotime("+1 day",$to_date_nuovoevento);
           	$to_date_vecchioevento=$vecchioevento['to_date'];
           	//questa � la met� a sinistra del evento (viene prima)
	        	if(mrbsGetValidEntry($vecchioevento['from_date'],
	            		strtotime("-1 day",$from_date_nuovoevento),
	            		$weekday_nuovoevento,$debug)){
	            			
           	 			$row=mrbsGetOccurence($vecchioevento['occur_id2'],$debug);
	            		if(sizeof($row)==0){
	            			/*die("mrbs_sql.inc.php, errore in mrbsHandle\
	            				OverlayedOccurence(), output di\
	            				mrbsGetOccurence($vecchioevento[occur_id2],$debug)\
	            				vuoto");*/
	            			Header("Location: month.php");
	            		}
	            		if($debug){
	            				echo "caso 2 inserimento prima:<br>\n";
	            		}
    				 	mrbsAddsOccurenceHM($row['room_id'],
    				 			$vecchioevento['from_date'],
	            				strtotime("-1 day",$from_date_nuovoevento),
    				 			$row['entry_id'],$weekday_nuovoevento,
    				 			$created_by_nuovoevento,
    				 			$vecchioevento['from_time'],$vecchioevento['to_time'],
    				 			$row['typeoflesson'],$debug);
	            	}else{//entry era valida?
	            		if($debug){
	            			echo "entry inutile non aggiunta<br>\n";
	            		}
	            	}//fine gestione entry valida
    			}//fine compareday($to_date_nuovoevento,$vecchioevento['to_date'])>0
    		
       //valido la entry
		if(mrbsGetValidEntry($from_date_vecchioevento,$to_date_vecchioevento,$weekday_nuovoevento,$debug)){
			mrbsUpdateOccurTime($from_date_vecchioevento,$to_date_vecchioevento,$vecchioevento['from_time'],$vecchioevento['to_time'],$vecchioevento['occur_id2'],$debug);
		}else{
			//l'entry � inutile va cancellata
				mrbsDelsOccurence($vecchioevento['occur_id2'],$debug);
        }
    }//questo chiude il ciclo while sulle varie entry


	return $id;
}

function mrbsDelOccurFromEntryId($id){
	global $tbl_occur;
	$sql="DELETE FROM $tbl_occur WHERE entry_id=$id";
	if(sql_command($sql)<0){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	return 1;
}
function mrbsDelEntry2($id){
	global $tbl_entry2;
	$sql="DELETE FROM $tbl_entry2 WHERE id=$id";
	if(sql_command($sql)<0){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	return 1;
}



function mrbsGetEntryInfo($id){
	global $tbl_entry2;
	global $tbl_cdl;
	
	$sql = "
	SELECT entry2.id,
	       entry2.created_by,
	       entry2.description,
	       entry2.teacher,
		   entry2.shortitle,
		   entry2.timestamp,
		   entry2.typeofdegree,
	       entry2.SSD,
	       entry2.year,
	       entry2.crediti,
	       cdl.id as cdlid,
	       cdl.descrizione as collegio
	FROM  $tbl_entry2 entry2
	LEFT JOIN $tbl_cdl cdl ON entry2.CDL=cdl.id
	WHERE entry2.id=$id";

	$res = sql_query($sql);
	if (!$res) {{fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".$sql.sql_error());}}
	if(sql_count($res)>0){
		$row=sql_row_keyed($res,0);
	}
	sql_free($res);
	return $row;
}

/* $from_date timestamp
 * $to_date timestamp
 * $from_time ora in formato H:M
 * $to_time ora in formato H:M	
 * $occur_id id in formato numerico
 **/
function mrbsUpdateOccurTime($from_date,$to_date,$from_time,$to_time,$occur_id,$debug=0){
	global $tbl_occur;
	if($debug==1){
		echo "mrbsUpdateOccurTime(".date("r",$from_date).",".date("r",$to_date).",$from_time,$to_time,$occur_id,$debug)";
		
	}
	$from_date=convert_am7($from_date);
	$to_date=convert_pm7($to_date);
       	$sql="UPDATE $tbl_occur SET
			from_date=".sql_syntax_timestamp_to_unix($from_date).",
            to_date=".sql_syntax_timestamp_to_unix($to_date).",
            from_time='$from_time',
            to_time='$to_time'
            WHERE id=$occur_id";
            /*if($debug==1){
            		echo "\n<br>SQL: $sql<br>\n";
            }*/
            if(sql_command($sql)<0) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
            
    
}
/** ritorna le occorrenze in conflitto con quella immessa 
	in teoria basterebbe solo l'id ma in pratica � pi� semplice
	e pi� generico immettendo tutti i dati
	$ending_time -> in formaot H:M
	$from_time ->in formato H:M
	$begin_time -> in formato h:M
	$from_time -> i formato H:M

*/
function mrbsGetOverlaysHM($room_id, $begin_time, $ending_time, $weekday_num,$from_date,$to_date,$id="",$debug=0){
	global $tbl_occur;global $tbl_entry2;
    $from_date=convert_am7($from_date);
    $to_date=convert_pm7($to_date);
    if($debug==1){
    	echo "mrbsgetOverlays($room_id, $begin_time, $ending_time, $weekday_num,".date("r",$from_date).",".date("r",$to_date).",$id,$debug)<br>\n";
    }
    $time_costraint=   "(to_time>\"$begin_time\" AND from_time<\"$ending_time\")";
    $date_costraint="(unix_timestamp(to_date)>='$from_date' AND unix_timestamp(from_date)<='$to_date')";
    $query="select occur.id as occur_id2,
    teacher,
    shortitle,
    unix_timestamp(from_date) as from_date,
    unix_timestamp(to_date) as to_date,
    occur.room_id,
    weekday,
    from_time,
    to_time,
    occur.entry_id,
    typeoflesson
    FROM $tbl_occur occur JOIN $tbl_entry2 entry2 ON 
    	entry2.id=occur.entry_id
    WHERE (weekday=$weekday_num
    AND room_id=$room_id ";
    if($id!=""){
    		$query.="AND occur.id!=$id ";
    }
    $query.=" AND ".$time_costraint." 
    AND ".$date_costraint.")
    ORDER BY to_time";
        $res=sql_query($query);
    if(!$res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
    return $res;
	
}

/** ritorna le occorrenze in conflitto con quella immessa 
	in teoria basterebbe solo l'id ma in pratica � pi� semplice
	e pi� generico immettendo tutti i dati
	$ending_time -> in timestamp
	$from_time ->in timestamp

*/
function mrbsgetOverlays($room_id, $begin_time, $ending_time, $weekday_num,$from_date,$to_date,$id="",$debug=0){
    $from_date=convert_am7($from_date);
    $to_date=convert_pm7($to_date);
    if($debug==1){
    	echo "mrbsgetOverlays($room_id, ".date("H:i",$begin_time).",".date("H:i",$ending_time).", $weekday_num,".date("r",$from_date).",".date("r",$to_date).",$id,$debug)<br>\n";
    }
    return mrbsGetOverlaysHM($room_id, date("H:i",$begin_time),date("H:i",$ending_time), $weekday_num,$from_date,$to_date,$id,0);
}
function mrbsgetLimitTime($room_id, $begin_time, $weekday_num){
    global $tbl_occur;
    global $eveningends;
    global $eveningends_minutes;
    global $resolution;
    $begin_time_hour=date("H:i",$begin_time);

    $time_costraint="(from_time>\"$begin_time_hour\")";
    $date_costraint="(unix_timestamp(to_date)>=$begin_time AND unix_timestamp(from_date)<=$begin_time)";
    $query="select TIME_FORMAT(min(from_time),'%H'), TIME_FORMAT(min(from_time),'%i')from $tbl_occur where (weekday=$weekday_num AND room_id=$room_id AND ".$time_costraint." AND ".$date_costraint.")";
    $res=sql_query($query);
    
    
    if(! $res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}

	   $row=sql_row($res,0);
	   sql_free($res);
	   if($row[0]==''){
	        $time=($eveningends*60+$eveningends_minutes)*60;
	        $time_t=$time+$resolution;;
	        return $time_t;
	   }else{
	       return ($row[0]*60+$row[1])*60;
	   }
//	   return $row[0];
//	}
}

function mrbsGetOccurByEvent($id){
	global $tbl_occur;
	global $tbl_area;
	global $tbl_room;
	$SQL="select occur.id,
				occur.room_id,
				room.room_name,
				area.description as area_name,
				occur.from_date,
				occur.to_date,
				occur.from_time,
				occur.to_time,
				occur.weekday,
				occur.entry_id,
				occur.typeoflesson
		FROM $tbl_occur occur
			join $tbl_room room on occur.room_id=room.id
			join $tbl_area area on room.area_id=area.id
		WHERE occur.entry_id=$id
		ORDER BY occur.weekday,occur.from_date";
	$res=sql_query($SQL);
	if (! $res) {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	return $res;
	
}
//obsolete
function mrbsReturninCompatibilities($aulaid, $from_time, $to_time, $weekday,$from_date,$to_date){
    global $tbl_occur;
    $time_costraint="( ".
        "(('$from_time'>from_time) OR ('$to_time'<=from_time))".
        "AND ".
        "(('$to_time'<from_time) OR ('$from_time'>=to_time))".
        "AND ".
        "(('$from_time'<from_time) OR ('$to_time'>to_time))".
        ")";
    $date_costraint="(".
        "((from_date<'$from_date')OR(from_date>='$to_date'))".
        "AND".
        "((from_date>='$from_date')OR(to_date>'$from_date'))".
        ")";
    $query="select * from $tbl_occur where (weekday=$weekday AND room_id=$aulaid AND ".$time_costraint." AND ".$date_costraint.")";
    $res=sql_query($query);
    if(!$res){
	    fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;
    }
    return $res;
}
function mrbsGetOccurence($id,$debug=0){
    global $tbl_occur;
    if($debug==1){
    	echo "mrbsGetOccurence($id,$debug)";
    }
    $query="SELECT * FROM $tbl_occur where $tbl_occur.id=$id";
    $res=sql_query($query);
    if(!$res)
	   {fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;
    }
    return sql_row_keyed($res,0);   
}
//testa se una entry sia valida
//condizioni per cui ritorna false:
//from_time>=to_time FIXME
//from_date>=to_date
//tra from_date e to_date non � compreso un weekday
//from_date ->timestamp
//to_date ->timestamp
//from_time -> HH:MM:ss
//to_time ->HH:MM:ss
//weekday ->int [0;6]
function mrbsGetValidEntry($from_date,$to_date,$weekday,$debug=0){
	if($debug==1){
		echo "mrbsGetValidEntry(".date("r",$from_date).",".date("r",$to_date).",$weekday,$debug)<br>\n";
		
	}
	$from_date_=mktime(0, 0, 0, date("m",$from_date)  , date("d",$from_date), date("Y",$from_date));
	$to_date_=mktime(0, 0, 0, date("m",$to_date)  , date("d",$to_date)+1, date("Y",$to_date));
	if($from_date>$to_date){
		return 0;
	}
	$temp=$from_date_;
	while($temp<$to_date_){
		if(date("w",$temp)==$weekday){
			return 1;
		}
		$temp=strtotime("+1 day",$temp);
		
	}
	return 0;
}


function mrbsGetRoomInfo($id){

	global $tbl_room;
	global $tbl_area;
	$QUERY="SELECT r.room_name,area_name FROM $tbl_area a JOIN $tbl_room r ON a.id=r.area_id WHERE r.id=$id";
	
	$res=sql_query($QUERY);
	if(!$res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	return sql_row_keyed($res,0);
}
function mrbsGetRooms(){
	global $tbl_room;
	global $tbl_area;
	$res=sql_query("SELECT r.id rid,r.room_name,a.description as area_name FROM $tbl_area a JOIN $tbl_room r ON a.id=r.area_id ORDER BY a.area_name,r.id");
	if(!$res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	$f=0;
	$result=array();
	while($row=sql_row_keyed($res,$f++)){
			$result[$row[rid]]=$row[area_name]." - ".$row[room_name];
		
	}
		
	return $result;
}

function mrbsAddCDL($descrizione){
	global $tbl_cdl;
	$sql="insert into $tbl_cdl(descrizione)values('$descrizione')";
	if(sql_command($sql)<0){
		fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;
	}
}
function mrbsUpdateCDL($id,$descrizione){
	global $tbl_cdl;
	$sql="update $tbl_cdl set descrizione='$descrizione' where id=$id";
	if(sql_command($sql)<0){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
}
function mrbsDelCDL($id){
	global $tbl_cdl;
	$sql="delete from $tbl_cdl where id=$id";
	if(sql_command($sql)<0){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
}

function mrbsGetAllCDL(){
	return mrbsGetCdl();
	
}
function mrbsGetCdl($id=""){
	global $tbl_cdl;
	if(is_numeric($id)){
		$constraint=" WHERE id=$id ";
	}
	$sql="select id,descrizione from $tbl_cdl $constraint";
	$res=sql_query($sql);
	if(!$res){
		//die(__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());
		Header("Location: month.php");
	}
	$rows=array();
	if(sql_count($res)>0){ 
		$count=0;
		while($temp=sql_row_keyed($res,$count++)){
				if($temp!=0){
					$rows[$temp['id']]=$temp['descrizione'];
				}
		}
	}
	return $rows;
}



function mrbsGetAreaInfo($id)
{
	global $tbl_area;
	$sql="SELECT area_name,description FROM $tbl_area WHERE (id = $id)";
	$res = sql_query($sql);
	if(!$res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	$area_info=array();
	if(sql_count($res)>0){
		$area_info=sql_row_keyed($res,0);
	}
	return $area_info;
}

function mrbsGetAllAreas()
{
	global $tbl_area;

	$res = sql_query("SELECT id,area_name,description as address FROM $tbl_area");
	if (! $res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	$areas=array();
	if (sql_count($res) > 0) {
		for ($i = 0; ($row = sql_row_keyed($res, $i)); $i++) {
			$areas[]=$row;
		}
	}
	return $areas;
}



function mrbsGetRoominArea($id){
	global $tbl_room;
	$sql="select id, room_name, description, capacity from $tbl_room where area_id=$id order by room_name";
	$res = sql_query($sql);

	if (! $res) {echo $sql."<br>";fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
	$rooms=array();	
	if (sql_count($res) > 0) {
		
		for ($i = 0; ($row = sql_row_keyed($res, $i)); $i++) {
			$rooms[]=$row;
			
		}
	}
	return $rooms;
	
}

function mrbsEsporta($from_date,$to_date,$debug=0){
	if($debug==1){
		echo "mrbsEsporta(".date("r",$from_date).",".date("r",$to_date).",$debug)";
	}
	$costraint=" ORDER BY entry2.CDL,occur.entry_id ";
	return	mrbsEsportaDONTCALLOUTSIDE($costraint,$debug,$from_date,$to_date);
}
function mrbsEsportaFilterByCreator($from_date,$to_date,$creator,$debug=0){
	if($debug==1){
		echo "mrbsEsportaFilterByCreator(".date("r",$from_date).",".date("r",$to_date).",$creator,$debug)";
		
	}
	$costraint=" AND occur.created_by='$creator' ORDER BY occur.timestamp DESC ";
	mrbsEsportaDONTCALLOUTSIDE($costraint,$debug,$from_date,$to_date);
	
}
function mrbsEsportaDONTCALLOUTSIDE($costraint,$debug,$from_date,$to_date){
	if($debug){
		echo "mrbsEsportaDONTCALLOUTSIDE('$costraint',$debug,$from_date,$to_date)";
	}
	global $tbl_entry2;
    global $tbl_room;
    global $tbl_area;
    global $tbl_occur;
    global $tbl_cdl;
    
	  $SQL="SELECT TIME_FORMAT(occur.from_time,'%H:%i:%s') as from_time,".
        "occur.weekday,TIME_FORMAT(occur.to_time,'%H:%i:%s') as to_time,".
        "room.room_name,area.description as area_description,occur.from_date as from_date_str,occur.to_date as to_date_str,".
        "DATE_FORMAT(occur.from_date,\"%e-%m-%Y\") as from_date,".
        "DATE_FORMAT(occur.to_date,\"%e-%m-%Y\") as to_date,entry2.teacher,".
		"entry2.description,entry2.shortitle,".
		"entry2.typeofdegree,occur.typeoflesson,".
		"entry2.id,entry2.SSD,".
		"entry2.year,entry2.crediti,occur.timestamp,".
		"occur.entry_id,occur.id, occur.created_by,".
		"entry2.CDL ".
        "FROM $tbl_room room ".
        "JOIN $tbl_area area ON room.area_id=area.id ".
        "JOIN $tbl_occur occur ON occur.room_id=room.id ".
        "JOIN $tbl_entry2 entry2 ON entry2.id=occur.entry_id  ";

        if($from_date!=-1&&$to_date!=-1){
        	$SQL.=" WHERE NOT (occur.to_date<FROM_UNIXTIME($from_date) ||".
        "occur.from_date>FROM_UNIXTIME($to_date)) ";

	        $f=$from_date;
	        $days=0;
	        $max=strtotime("+7 day",$f);
	        $max=min($max,$to_date);
	        while($f<$max){
	        	$days++;
	        	$weeklimit.=" occur.weekday=".date("w",$f)." ";
	        	$nuovo=strtotime("+1 day",$f);
	        	if($nuovo<$max){
	        		$weeklimit.=" OR ";
	        	}
	        	$f=$nuovo;
	        }
	        if($days<7){
	        	$SQL.=" AND (".$weeklimit.")";
	        }
        }
        $SQL.=" $costraint ";
        if($debug!=0){
        	echo $SQL;
        }
  $res = sql_query($SQL);
  if(!$res){fatal_error(0,__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());return 0;}
  $counter=0;
  $entry[]=array();
    while (($temp = sql_row_keyed($res, $counter++))!=0) {
    	$entry[]=$temp;
    }
	return $entry;

	
}
function mrbsDelLog($debug=0){
	global $tbl_log;
	global $tbl_log_time;
	if($debug==1){
		echo "mrbsDelLog($debug)"; 
		echo $sql;
	}
		$sql="truncate $tbl_log";
		if(sql_command($sql)<0){
			fatal_error(0,sql_error());
		}
		$sql="truncate $tbl_log_time";
		if(sql_command($sql)<0){
			fatal_error(0,sql_error());
		}
}
function mrbsInitLog(&$LOG,$debug=0){
	global $tbl_log;
	global $devlog;
	$pagina = basename($_SERVER['SCRIPT_NAME']);
	$attributi = $_SERVER['QUERY_STRING'];
	$username=getUserName();
	if($username==NULL){
		$username="anonimo";
	}
	$sql="insert into $tbl_log(pagina,ip,user,richiesta,useragent)values('$pagina','$_SERVER[REMOTE_ADDR]','$username','$attributi','$_SERVER[HTTP_USER_AGENT]')";

	if($debug==1){
		echo "mrbsLog($debug)"; 
		echo $sql;
	}
	$id=0;
	if($devlog==1){
		sql_mutex_lock($tbl_log);
	  if(sql_command($sql)<0){
	  	echo "query: $sql";
	  	
	  	echo(__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());
		
	  }
	  $id=sql_insert_id($tbl_log,'id');

	  sql_mutex_unlock($tbl_log);

	}
	$LOG[ID]=$id;
	return $id;
}

function mrbsLogReg($LOG,$descr,$debug=0){
	global $tbl_log_time;
	global $devlog;
	
	if($devlog==1){
		if($LOG[ID]==0){
			echo(__FILE__."(".__LINE__.")".__FUNCTION__.":"."errore nella acquisizione del id x il log");
			return;
		}
		
		$TOTAL=microtime_float()-$LOG[TIME];
		$vir = ',';
		$pon = '.';
		$v1 = str_replace($vir,$pon, $TOTAL);
		$sql="insert into $tbl_log_time(id,time,descrizione)values($LOG[ID],$v1,'$descr')";

	    if(sql_command($sql)<0){
		  	echo "query: $sql";
		  	echo(__FILE__."(".__LINE__.")".__FUNCTION__.":".sql_error());

	  	}
	}
	
}
function mrbsGetRoomsNumber($area=0){
	global $tbl_room;
	if($area!=0){
		$num=sql_query1("select count(id) from $tbl_room where area_id=$area");
	}else{
		$num=sql_query1("select count(id) from $tbl_room");
	}
	return $num;
}

function mrbsGetRoomArea($id)
{
	global $tbl_room;

	$id = sql_query1("SELECT area_id FROM $tbl_room WHERE (id = $id)");
	if ($id <= 0) return 0;
	return $id;
}
#28 settembre 2007 ed.matteucci@gmail.com
?>
